! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.
! NCbNr[A

program gtcont
    use gtool
    integer:: argind
    type(VARYING_STRING):: argument, optname, optvalue
    type(GT_FIGURE):: fig
    type(GT_DEVICE):: dev
    integer:: i
    logical:: arg_given = .FALSE.
continue
    call Open(fig)
    do, i = 1, GtArgCount()
        call GtArgGet(i, argument)
        if (extract(argument, 1, 1) == '-') then
            print *, "boolean option ", char(argument), " ignored"
        else if (NameValueForm(argument, optname, optvalue)) then
            print *, "assignment option ", char(argument), " ignored"
        else
            arg_given = .TRUE.
            call BuildPutFigure(fig, argument)
        endif
    enddo
    if (.not. arg_given) then
        call BuildPutFigure(fig, var_str("gtool.nc"))
    endif
    call Open(dev)
    call Display(dev, fig)
    call Close(fig)
    call Close(dev)
contains

    logical function &
    NameValueForm(argument, name, value) result(result)
        type(VARYING_STRING), intent(in):: argument
        type(VARYING_STRING), intent(out):: name, value
        character(len = *), parameter:: WORDCHARS &
            = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_:"
        integer:: i
    continue
        i = index(argument, "=")
        if (i == 0) goto 999
        name = extract(argument, 1, i - 1)
        if (verify(name, WORDCHARS) /= 0) goto 999
        result = .TRUE.
        value = extract(argument, i + 1)
        return

    999 continue
        result = .FALSE.
        name = ""
        value = ""
    end function

    subroutine BuildPutFigure(fig, varname)
        type(VARYING_STRING), intent(in):: varname
        type(GT_FIGURE), intent(inout):: fig
        type(GT_VARIABLE):: var
        call Open(var, varname)
        select case(ndims(var))
        case(1)
            call Put(fig, Line(var))
        case(2:)
            call Put(fig, Contours(var))
        case default
            call AbortProgram("cannot handle a variable without any dimension")
        end select
    end subroutine
end program

